#include <cstdio>
#include <cstdlib>
#include <vector>

extern int max_level (std::vector<int> X, std::vector<int> Y, std::vector<int> D, std::vector<int> W);

void my_assert (bool x) {
  if (!x) {
    puts("Input error!");
    exit(0);
  }
}

int main() {
    int N;
    my_assert(scanf("%d", &N) == 1);
    
    std::vector<int> X(N), Y(N), D(N), W(N);
    for(int i = 0; i < N; i++) {
        my_assert(scanf("%d %d %d %d", &X[i], &Y[i], &D[i], &W[i]) == 4);
    }

    int ans = max_level(X, Y, D, W);
    printf("%d\n", ans);
    
    return 0;
}
